__version__='$Revision: 1.2 $'[11:-2]

class TableView_Mixin:

    def renderTable(self, REQUEST=None):
        """Return an html <table>...</table> representation of the folder we
        were called on."""

        # XXX go looking for our folder; this is a bad interface
        
        if REQUEST.PARENTS[0].meta_type == 'TableView':
            folder = REQUEST.PARENTS[1]
        else:
            folder = REQUEST.PARENTS[0]

        columns = self.objectValues('TableViewColumn')
        columns.sort(lambda a,b: cmp(a.columnOrder, b.columnOrder))
        
        # The TableView property "rowIds" contains the name of the
        # method to call to get the list of id's of the items to
        # display in the table.  Get the name of the method, aquire it
        # from the folder, and call it.

        rowIds = getattr(folder, self.rowIds)()

        # rows is a list of (id, obj) pairs for each id to display
        
        rows = map(lambda rowId, folder=folder: (rowId, folder._getOb(rowId).aq_base),
                   rowIds)

        # the TableView orderRowsBy property contains the name of the item's
        # property (e.g. "lastName") to sort by

        orderRowsBy = self.orderRowsBy
        if orderRowsBy:
            rows.sort(lambda a, b, folder=folder, orderRowsBy=orderRowsBy:
                      cmp(_getPropertyFromObj(folder, a[0], a[1], orderRowsBy),
                          _getPropertyFromObj(folder, b[0], b[1], orderRowsBy)))
        
        result = "<TABLE BORDER=\"%s\">\n" % self.tableBorder
        
        for item in rows:
            result = result + " <TR>\n"
            for column in columns:
                cellValue = _getPropertyFromObj(folder, item[0], item[1], column.columnProperty)
                result = result + "  <TD>" + cellValue + "</TD>\n"
            result = result + " </TR>\n"
            
        result = result + "</TABLE>\n"
        return result


NEWLINE = chr(10)

def _getPropertyFromObj(folder, objId, obj, propertyName):
    try:
        value = getattr(obj, propertyName)
    except AttributeError:
        raise AttributeError, ("Item '%s' in '%s' does not have the '%s' property"
                               % (objId, folder.id, propertyName))
    return value

def _getPropertyFromId(folder, id, propertyName):
    return _getPropertyFromObj(folder, id, folder._getOb(id).aq_base, propertyname)
